# Serialized Form

## Package org.apache.xerces.dom

### Class org.apache.xerces.dom.AttributeMap extends NamedNodeMapImpl implements Serializable

serialVersionUID:
  8872606282138665383L

### Class org.apache.xerces.dom.AttrImpl extends NodeImpl implements Serializable

serialVersionUID:
  7277707688218972102L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream ois)
                     throws java.lang.ClassNotFoundException,
                            java.io.IOException

Deserialize object.

Throws:
  `java.lang.ClassNotFoundException`
  `java.io.IOException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Serialize object.

Throws:
  `java.io.IOException`

### Serialized Fields

#### value

    java.lang.Object value

This can either be a String or the first child node.

#### name

    java.lang.String name

Attribute name.

### Class org.apache.xerces.dom.AttrNSImpl extends AttrImpl implements Serializable

serialVersionUID:
  -781906615369795414L

### Serialized Fields

#### namespaceURI

    java.lang.String namespaceURI

DOM2: Namespace URI.

#### localName

    java.lang.String localName

DOM2: localName.

### Class org.apache.xerces.dom.CDATASectionImpl extends TextImpl implements Serializable

serialVersionUID:
  2372071297878177780L

### Class org.apache.xerces.dom.CharacterDataImpl extends ChildNode implements Serializable

serialVersionUID:
  7931170150428474230L

### Serialized Fields

#### data

    java.lang.String data

### Class org.apache.xerces.dom.ChildNode extends NodeImpl implements Serializable

serialVersionUID:
  -6112455738802414002L

### Serialized Fields

#### previousSibling

    ChildNode previousSibling

Previous sibling.

#### nextSibling

    ChildNode nextSibling

Next sibling.

### Class org.apache.xerces.dom.CommentImpl extends CharacterDataImpl implements Serializable

serialVersionUID:
  -2685736833408134044L

### Class org.apache.xerces.dom.CoreDocumentImpl extends ParentNode implements Serializable

serialVersionUID:
  0L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

The serialized forms of the user data and node table maps are Hashtables. Convert them into WeakHashMaps on load.

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

To allow DOM trees serialized by newer versions of Xerces to be read by older versions briefly move the user data and node table into Hashtables.

Throws:
  `java.io.IOException`

### Serialized Fields

#### docType

    DocumentTypeImpl docType

Document type.

#### docElement

    ElementImpl docElement

Document element.

#### encoding

    java.lang.String encoding

Experimental DOM Level 3 feature: Document encoding

#### actualEncoding

    java.lang.String actualEncoding

Experimental DOM Level 3 feature: Document actualEncoding

#### version

    java.lang.String version

Experimental DOM Level 3 feature: Document version

#### standalone

    boolean standalone

Experimental DOM Level 3 feature: Document standalone

#### fDocumentURI

    java.lang.String fDocumentURI

Experimental DOM Level 3 feature: documentURI

#### userData

    java.util.Map<K,V> userData

Table for user data attached to this document nodes.

#### identifiers

    java.util.Hashtable<K,V> identifiers

Identifiers.

#### changes

    int changes

Number of alterations made to this document since its creation. Serves as a "dirty bit" so that live objects such as NodeList can recognize when an alteration has been made and discard its cached state information.

Any method that alters the tree structure MUST cause or be accompanied by a call to changed(), to inform it that any outstanding NodeLists may have to be updated.

(Required because NodeList is simultaneously "live" and integer- indexed -- a bad decision in the DOM's design.)

Note that changes which do not affect the tree's structure -- changing the node's name, for example -- do _not_ have to call changed().

Alternative implementation would be to use a cryptographic Digest value rather than a count. This would have the advantage that "harmless" changes (those producing equal() trees) would not force NodeList to resynchronize. Disadvantage is that it's slightly more prone to "false negatives", though that's the difference between "wildly unlikely" and "absurdly unlikely". IF we start maintaining digests, we should consider taking advantage of them. Note: This used to be done a node basis, so that we knew what subtree changed. But since only DeepNodeList really use this today, the gain appears to be really small compared to the cost of having an int on every (parent) node plus having to walk up the tree all the way to the root to mark the branch as changed everytime a node is changed. So we now have a single counter global to the document. It means that some objects may flush their cache more often than necessary, but this makes nodes smaller and only the document needs to be marked as changed.

#### allowGrammarAccess

    boolean allowGrammarAccess

Allow grammar access.

#### errorChecking

    boolean errorChecking

Bypass error checking.

#### xmlVersionChanged

    boolean xmlVersionChanged

#### documentNumber

    int documentNumber

The following are required for compareDocumentPosition

#### nodeCounter

    int nodeCounter

#### nodeTable

    java.util.Map<K,V> nodeTable

#### xml11Version

    boolean xml11Version

### Class org.apache.xerces.dom.DeferredAttrImpl extends AttrImpl implements Serializable

serialVersionUID:
  6903232312469148636L

### Class org.apache.xerces.dom.DeferredAttrNSImpl extends AttrNSImpl implements Serializable

serialVersionUID:
  6074924934945957154L

### Class org.apache.xerces.dom.DeferredCDATASectionImpl extends CDATASectionImpl implements Serializable

serialVersionUID:
  1983580632355645726L

### Class org.apache.xerces.dom.DeferredCommentImpl extends CommentImpl implements Serializable

serialVersionUID:
  6498796371083589338L

### Class org.apache.xerces.dom.DeferredDocumentImpl extends DocumentImpl implements Serializable

serialVersionUID:
  5186323580749626857L

### Serialized Fields

#### fNamespacesEnabled

    boolean fNamespacesEnabled

DOM2: For namespace support in the deferred case.

### Class org.apache.xerces.dom.DeferredDocumentTypeImpl extends DocumentTypeImpl implements Serializable

serialVersionUID:
  -2172579663227313509L

### Class org.apache.xerces.dom.DeferredElementDefinitionImpl extends ElementDefinitionImpl implements Serializable

serialVersionUID:
  6703238199538041591L

### Class org.apache.xerces.dom.DeferredElementImpl extends ElementImpl implements Serializable

serialVersionUID:
  -7670981133940934842L

### Class org.apache.xerces.dom.DeferredElementNSImpl extends ElementNSImpl implements Serializable

serialVersionUID:
  -5001885145370927385L

### Class org.apache.xerces.dom.DeferredEntityImpl extends EntityImpl implements Serializable

serialVersionUID:
  4760180431078941638L

### Class org.apache.xerces.dom.DeferredEntityReferenceImpl extends EntityReferenceImpl implements Serializable

serialVersionUID:
  390319091370032223L

### Class org.apache.xerces.dom.DeferredNotationImpl extends NotationImpl implements Serializable

serialVersionUID:
  5705337172887990848L

### Class org.apache.xerces.dom.DeferredProcessingInstructionImpl extends ProcessingInstructionImpl implements Serializable

serialVersionUID:
  -4643577954293565388L

### Class org.apache.xerces.dom.DeferredTextImpl extends TextImpl implements Serializable

serialVersionUID:
  2310613872100393425L

### Class org.apache.xerces.dom.DocumentFragmentImpl extends ParentNode implements Serializable

serialVersionUID:
  -7596449967279236746L

### Class org.apache.xerces.dom.DocumentImpl extends CoreDocumentImpl implements Serializable

serialVersionUID:
  515687835542616694L

### Serialized Fields

#### eventListeners

    java.util.Hashtable<K,V> eventListeners

Table for event listeners registered to this document nodes.

#### mutationEvents

    boolean mutationEvents

Bypass mutation events firing.

#### savedEnclosingAttr

    org.apache.xerces.dom.DocumentImpl.EnclosingAttr savedEnclosingAttr

### Class org.apache.xerces.dom.DocumentTypeImpl extends ParentNode implements Serializable

serialVersionUID:
  7751299192316526485L

### Serialized Fields

#### name

    java.lang.String name

Document type name.

#### entities

    NamedNodeMapImpl entities

Entities.

#### notations

    NamedNodeMapImpl notations

Notations.

#### elements

    NamedNodeMapImpl elements

Elements.

#### publicID

    java.lang.String publicID

#### systemID

    java.lang.String systemID

#### internalSubset

    java.lang.String internalSubset

#### doctypeNumber

    int doctypeNumber

The following are required for compareDocumentPosition

#### userData

    java.util.Hashtable<K,V> userData

### Class org.apache.xerces.dom.ElementDefinitionImpl extends ParentNode implements Serializable

serialVersionUID:
  -8373890672670022714L

### Serialized Fields

#### name

    java.lang.String name

Element definition name.

#### attributes

    NamedNodeMapImpl attributes

Default attributes.

### Class org.apache.xerces.dom.ElementImpl extends ParentNode implements Serializable

serialVersionUID:
  3717253516652722278L

### Serialized Fields

#### name

    java.lang.String name

Element name.

#### attributes

    AttributeMap attributes

Attributes.

### Class org.apache.xerces.dom.ElementNSImpl extends ElementImpl implements Serializable

serialVersionUID:
  -9142310625494392642L

### Serialized Fields

#### namespaceURI

    java.lang.String namespaceURI

DOM2: Namespace URI.

#### localName

    java.lang.String localName

DOM2: localName.

### Class org.apache.xerces.dom.EntityImpl extends ParentNode implements Serializable

serialVersionUID:
  -3575760943444303423L

### Serialized Fields

#### name

    java.lang.String name

Entity name.

#### publicId

    java.lang.String publicId

Public identifier.

#### systemId

    java.lang.String systemId

System identifier.

#### encoding

    java.lang.String encoding

Encoding

#### inputEncoding

    java.lang.String inputEncoding

Input Encoding

#### version

    java.lang.String version

Version

#### notationName

    java.lang.String notationName

Notation name.

#### baseURI

    java.lang.String baseURI

base uri

### Class org.apache.xerces.dom.EntityReferenceImpl extends ParentNode implements Serializable

serialVersionUID:
  -7381452955687102062L

### Serialized Fields

#### name

    java.lang.String name

Name of Entity referenced

#### baseURI

    java.lang.String baseURI

Base URI

### Class org.apache.xerces.dom.NamedNodeMapImpl extends java.lang.Object implements Serializable

serialVersionUID:
  -7039242451046758020L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### flags

    short flags

#### nodes

    java.util.List<E> nodes

Nodes.

#### ownerNode

    NodeImpl ownerNode

### Class org.apache.xerces.dom.NodeImpl extends java.lang.Object implements Serializable

serialVersionUID:
  -6316591992167219696L

### Serialization Methods

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Serialize object.

Throws:
  `java.io.IOException`

### Serialized Fields

#### ownerNode

    NodeImpl ownerNode

#### flags

    short flags

### Class org.apache.xerces.dom.NotationImpl extends NodeImpl implements Serializable

serialVersionUID:
  -764632195890658402L

### Serialized Fields

#### name

    java.lang.String name

Notation name.

#### publicId

    java.lang.String publicId

Public identifier.

#### systemId

    java.lang.String systemId

System identifier.

#### baseURI

    java.lang.String baseURI

Base URI

### Class org.apache.xerces.dom.ParentNode extends ChildNode implements Serializable

serialVersionUID:
  2815829867152120872L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream ois)
                     throws java.lang.ClassNotFoundException,
                            java.io.IOException

Deserialize object.

Throws:
  `java.lang.ClassNotFoundException`
  `java.io.IOException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Serialize object.

Throws:
  `java.io.IOException`

### Serialized Fields

#### ownerDocument

    CoreDocumentImpl ownerDocument

Owner document.

#### firstChild

    ChildNode firstChild

First child.

### Class org.apache.xerces.dom.ProcessingInstructionImpl extends CharacterDataImpl implements Serializable

serialVersionUID:
  7554435174099981510L

### Serialized Fields

#### target

    java.lang.String target

### Class org.apache.xerces.dom.PSVIAttrNSImpl extends AttrNSImpl implements Serializable

serialVersionUID:
  -3241738699421018889L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### fDeclaration

    org.apache.xerces.xs.XSAttributeDeclaration fDeclaration

attribute declaration

#### fTypeDecl

    org.apache.xerces.xs.XSTypeDefinition fTypeDecl

type of attribute, simpleType

#### fSpecified

    boolean fSpecified

If this attribute was explicitly given a value in the original document, this is true; otherwise, it is false

#### fValue

    ValidatedInfo fValue

Schema value

#### fValidationAttempted

    short fValidationAttempted

validation attempted: none, partial, full

#### fValidity

    short fValidity

validity: valid, invalid, unknown

#### fErrorCodes

    org.apache.xerces.xs.StringList fErrorCodes

error codes

#### fErrorMessages

    org.apache.xerces.xs.StringList fErrorMessages

error messages

#### fValidationContext

    java.lang.String fValidationContext

validation context: could be QName or XPath expression

### Class org.apache.xerces.dom.PSVIDocumentImpl extends DocumentImpl implements Serializable

serialVersionUID:
  -8822220250676434522L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Class org.apache.xerces.dom.PSVIElementNSImpl extends ElementNSImpl implements Serializable

serialVersionUID:
  6815489624636016068L

### Serialization Methods

#### readObject

    private void readObject(java.io.ObjectInputStream in)
                     throws java.io.IOException,
                            java.lang.ClassNotFoundException

Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### writeObject

    private void writeObject(java.io.ObjectOutputStream out)
                      throws java.io.IOException

Throws:
  `java.io.IOException`

### Serialized Fields

#### fDeclaration

    org.apache.xerces.xs.XSElementDeclaration fDeclaration

element declaration

#### fTypeDecl

    org.apache.xerces.xs.XSTypeDefinition fTypeDecl

type of element, could be xsi:type

#### fNil

    boolean fNil

true if clause 3.2 of Element Locally Valid (Element) (3.3.4) is satisfied, otherwise false

#### fSpecified

    boolean fSpecified

false if the element value was provided by the schema; true otherwise.

#### fValue

    ValidatedInfo fValue

Schema value

#### fNotation

    org.apache.xerces.xs.XSNotationDeclaration fNotation

http://www.w3.org/TR/xmlschema-1/#e-notation

#### fValidationAttempted

    short fValidationAttempted

validation attempted: none, partial, full

#### fValidity

    short fValidity

validity: valid, invalid, unknown

#### fErrorCodes

    org.apache.xerces.xs.StringList fErrorCodes

error codes

#### fErrorMessages

    org.apache.xerces.xs.StringList fErrorMessages

error messages

#### fValidationContext

    java.lang.String fValidationContext

validation context: could be QName or XPath expression

#### fSchemaInformation

    org.apache.xerces.xs.XSModel fSchemaInformation

the schema information property

### Class org.apache.xerces.dom.RangeExceptionImpl extends org.w3c.dom.ranges.RangeException implements Serializable

serialVersionUID:
  -9058052627467240856L

### Class org.apache.xerces.dom.TextImpl extends CharacterDataImpl implements Serializable

serialVersionUID:
  -5294980852957403469L

## Package org.apache.xerces.impl.dv

### Class org.apache.xerces.impl.dv.DatatypeException extends java.lang.Exception implements Serializable

serialVersionUID:
  1940805832730465578L

### Serialized Fields

#### key

    java.lang.String key

#### args

    java.lang.Object[] args

### Class org.apache.xerces.impl.dv.DVFactoryException extends java.lang.RuntimeException implements Serializable

serialVersionUID:
  -3738854697928682412L

### Class org.apache.xerces.impl.dv.InvalidDatatypeFacetException extends DatatypeException implements Serializable

serialVersionUID:
  -4104066085909970654L

### Class org.apache.xerces.impl.dv.InvalidDatatypeValueException extends DatatypeException implements Serializable

serialVersionUID:
  -5523739426958236125L

## Package org.apache.xerces.impl.dv.xs

### Class org.apache.xerces.impl.dv.xs.SchemaDateTimeException extends java.lang.RuntimeException implements Serializable

serialVersionUID:
  -8520832235337769040L

## Package org.apache.xerces.impl.io

### Class org.apache.xerces.impl.io.MalformedByteSequenceException extends java.io.CharConversionException implements Serializable

serialVersionUID:
  8436382245048328739L

### Serialized Fields

#### fFormatter

    MessageFormatter fFormatter

message formatter

#### fLocale

    java.util.Locale fLocale

locale for error message

#### fDomain

    java.lang.String fDomain

error domain

#### fKey

    java.lang.String fKey

key for the error message

#### fArguments

    java.lang.Object[] fArguments

replacement arguements for the error message

#### fMessage

    java.lang.String fMessage

message text for this message, initially null

## Package org.apache.xerces.impl.xpath

### Class org.apache.xerces.impl.xpath.XPathException extends java.lang.Exception implements Serializable

serialVersionUID:
  -948482312169512085L

### Serialized Fields

#### fKey

    java.lang.String fKey

## Package org.apache.xerces.impl.xpath.regex

### Class org.apache.xerces.impl.xpath.regex.ParseException extends java.lang.RuntimeException implements Serializable

serialVersionUID:
  -7012400318097691370L

### Serialized Fields

#### location

    int location

### Class org.apache.xerces.impl.xpath.regex.RegularExpression extends java.lang.Object implements Serializable

serialVersionUID:
  6242499334195006401L

### Serialized Fields

#### regex

    java.lang.String regex

A regular expression.

#### options

    int options

#### nofparen

    int nofparen

The number of parenthesis in the regular expression.

#### tokentree

    org.apache.xerces.impl.xpath.regex.Token tokentree

Internal representation of the regular expression.

#### hasBackReferences

    boolean hasBackReferences

## Package org.apache.xerces.impl.xs

### Class org.apache.xerces.impl.xs.XMLSchemaException extends java.lang.Exception implements Serializable

serialVersionUID:
  -9096984648537046218L

### Serialized Fields

#### key

    java.lang.String key

#### args

    java.lang.Object[] args

## Package org.apache.xerces.util

### Class org.apache.xerces.util.URI extends java.lang.Object implements Serializable

serialVersionUID:
  1601921774685357214L

### Serialized Fields

#### m_scheme

    java.lang.String m_scheme

Stores the scheme (usually the protocol) for this URI.

#### m_userinfo

    java.lang.String m_userinfo

If specified, stores the userinfo for this URI; otherwise null

#### m_host

    java.lang.String m_host

If specified, stores the host for this URI; otherwise null

#### m_port

    int m_port

If specified, stores the port for this URI; otherwise -1

#### m_regAuthority

    java.lang.String m_regAuthority

If specified, stores the registry based authority for this URI; otherwise -1

#### m_path

    java.lang.String m_path

If specified, stores the path for this URI; otherwise null

#### m_queryString

    java.lang.String m_queryString

If specified, stores the query string for this URI; otherwise null.

#### m_fragment

    java.lang.String m_fragment

If specified, stores the fragment for this URI; otherwise null

### Class org.apache.xerces.util.URI.MalformedURIException extends java.io.IOException implements Serializable

serialVersionUID:
  -6695054834342951930L